using System;

using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Text;

public partial class CSharp : System.Web.UI.Page
{
protected void Page_Load(object sender, EventArgs e)
{
    Response.Cache.SetCacheability(HttpCacheability.NoCache);
    if (IsPostBack)
    {
        PopulateCheckBoxArray();
    }
    BindGrid();
}

private void PopulateCheckBoxArray()
{
    ArrayList CheckBoxArray;
    if (ViewState["CheckBoxArray"] != null)
    {
        CheckBoxArray = (ArrayList)ViewState["CheckBoxArray"];
    }
    else
    {
        CheckBoxArray = new ArrayList();
    }

    int CheckBoxIndex;
    bool CheckAllWasChecked = false;
    CheckBox chkAll = (CheckBox)GridView1.HeaderRow.Cells[0].FindControl("chkAll");
    string checkAllIndex = "chkAll-" + GridView1.PageIndex;
    if (chkAll.Checked)
    {
        if (CheckBoxArray.IndexOf(checkAllIndex) == -1)
        {
            CheckBoxArray.Add(checkAllIndex);
        }
    }
    else
    {
        if (CheckBoxArray.IndexOf(checkAllIndex) != -1)
        {
            CheckBoxArray.Remove(checkAllIndex);
            CheckAllWasChecked = true;
        }
    }
    for (int i = 0; i < GridView1.Rows.Count; i++)
    {
        if (GridView1.Rows[i].RowType == DataControlRowType.DataRow)
        {
            CheckBox chk = (CheckBox)GridView1.Rows[i].Cells[0].FindControl("CheckBox1");
            CheckBoxIndex = GridView1.PageSize * GridView1.PageIndex + (i + 1);
            if (chk.Checked)
            {
                if (CheckBoxArray.IndexOf(CheckBoxIndex) == -1 && !CheckAllWasChecked)
                {
                    CheckBoxArray.Add(CheckBoxIndex);
                }
            }
            else
            {
                if (CheckBoxArray.IndexOf(CheckBoxIndex) != -1 || CheckAllWasChecked)
                {
                    CheckBoxArray.Remove(CheckBoxIndex);
                }
            }
        }
    }
    ViewState["CheckBoxArray"] = CheckBoxArray;
}

private void BindGrid()
{
    string strQuery = "select CustomerID,City,Country,PostalCode" + 
        " from customers";
    DataTable dt = new DataTable();
    String strConnString = System.Configuration.ConfigurationManager
                .ConnectionStrings["conString"].ConnectionString;
    SqlConnection con = new SqlConnection(strConnString);
    SqlDataAdapter sda = new SqlDataAdapter();
    SqlCommand cmd = new SqlCommand(strQuery);
    cmd.CommandType = CommandType.Text;
    cmd.Connection = con;
    try
    {
        con.Open();
        sda.SelectCommand = cmd;
        sda.Fill(dt);
        GridView1.DataSource = dt;
        GridView1.DataBind();
    }
    catch (Exception ex)
    {
        throw ex;
    }
    finally
    {
        con.Close();
        sda.Dispose();
        con.Dispose();
    }
}

private void ResetCheckBoxes()
{
    if (ViewState["CheckBoxArray"] != null)
    {
        ArrayList CheckBoxArray = (ArrayList)ViewState["CheckBoxArray"];
        string checkAllIndex = "chkAll-" + GridView1.PageIndex;

        if (CheckBoxArray.IndexOf(checkAllIndex) != -1)
        {
            CheckBox chkAll = (CheckBox)GridView1.HeaderRow.Cells[0].FindControl("chkAll");
            chkAll.Checked = true;
        }
        for (int i = 0; i < GridView1.Rows.Count; i++)
        {

            if (GridView1.Rows[i].RowType == DataControlRowType.DataRow)
            {
                if (CheckBoxArray.IndexOf(checkAllIndex) != -1)
                {
                    CheckBox chk = (CheckBox)GridView1.Rows[i].Cells[0].FindControl("CheckBox1");
                    chk.Checked = true;
                }
                else
                {
                    int CheckBoxIndex = GridView1.PageSize * (GridView1.PageIndex) + (i + 1);
                    if (CheckBoxArray.IndexOf(CheckBoxIndex) != -1)
                    {
                        CheckBox chk = (CheckBox)GridView1.Rows[i].Cells[0].FindControl("CheckBox1");
                        chk.Checked = true;
                    }
                }
            }
        }
    }
}

    public override void VerifyRenderingInServerForm(Control control)
    {
        /*Verifies that the control is rendered */
    }

protected void OnPaging(object sender, GridViewPageEventArgs  e)
{
    GridView1.PageIndex = e.NewPageIndex;
    GridView1.DataBind();
    ResetCheckBoxes();
}

  

protected void btnExportExcel_Click(object sender, EventArgs e)
{
    Response.Clear();
    Response.Buffer = true;
   
    Response.AddHeader("content-disposition", 
     "attachment;filename=GridViewExport.xls");
    Response.Charset = "";
    Response.ContentType = "application/vnd.ms-excel";
    StringWriter sw = new StringWriter();
    HtmlTextWriter hw = new HtmlTextWriter(sw);

    GridView1.AllowPaging = false;
    GridView1.DataBind(); 

    GridView1.HeaderRow.Style.Add("background-color", "#FFFFFF");
    GridView1.HeaderRow.Cells[0].Visible = false;
    GridView1.HeaderRow.Cells[1].Style.Add("background-color", "green");
    GridView1.HeaderRow.Cells[2].Style.Add("background-color", "green");
    GridView1.HeaderRow.Cells[3].Style.Add("background-color", "green");
    GridView1.HeaderRow.Cells[4].Style.Add("background-color", "green");
    if (ViewState["CheckBoxArray"] != null)
    {
        ArrayList CheckBoxArray = (ArrayList)ViewState["CheckBoxArray"];
        string checkAllIndex = "chkAll-" + GridView1.PageIndex;
        int rowIdx = 0;
        for (int i = 0; i < GridView1.Rows.Count; i++)
        {
            GridViewRow row = GridView1.Rows[i];
            row.Visible = false;

            if (row.RowType == DataControlRowType.DataRow)
            {
                if (CheckBoxArray.IndexOf(i + 1) != -1)
                {
                    row.Visible = true;
                    row.BackColor = System.Drawing.Color.White;
                    row.Cells[0].Visible = false;
                    row.Attributes.Add("class", "textmode");
                    if (rowIdx % 2 != 0)
                    {
                        
                        row.Cells[1].Style.Add("background-color", "#C2D69B");
                        row.Cells[2].Style.Add("background-color", "#C2D69B");
                        row.Cells[3].Style.Add("background-color", "#C2D69B");
                        row.Cells[4].Style.Add("background-color", "#C2D69B");
                    }
                    rowIdx++;
                }
            }
        }
    }
    GridView1.RenderControl(hw);
    string style = @"<style> .textmode { mso-number-format:\@; } </style>"; 
    Response.Write(style); 
    Response.Output.Write(sw.ToString());
    Response.End();
}

    protected void btnExportAll_Click(object sender, EventArgs e)
    {
        Response.Clear();
        Response.Buffer = true;

        Response.AddHeader("content-disposition",
         "attachment;filename=GridViewExport.xls");
        Response.Charset = "";
        Response.ContentType = "application/vnd.ms-excel";
        StringWriter sw = new StringWriter();
        HtmlTextWriter hw = new HtmlTextWriter(sw);

        GridView1.AllowPaging = false;
        GridView1.DataBind();

        GridView1.HeaderRow.Style.Add("background-color", "#FFFFFF");
        GridView1.HeaderRow.Cells[0].Visible = false;
        GridView1.HeaderRow.Cells[1].Style.Add("background-color", "green");
        GridView1.HeaderRow.Cells[2].Style.Add("background-color", "green");
        GridView1.HeaderRow.Cells[3].Style.Add("background-color", "green");
        GridView1.HeaderRow.Cells[4].Style.Add("background-color", "green");

        for (int i = 0; i < GridView1.Rows.Count; i++)
        {
            GridViewRow row = GridView1.Rows[i];
            row.BackColor = System.Drawing.Color.White;
            row.Cells[0].Visible = false;
            row.Attributes.Add("class", "textmode");
            if (i % 2 != 0)
            {
                row.Cells[1].Style.Add("background-color", "#C2D69B");
                row.Cells[2].Style.Add("background-color", "#C2D69B");
                row.Cells[3].Style.Add("background-color", "#C2D69B");
                row.Cells[4].Style.Add("background-color", "#C2D69B");
            }
        }
        GridView1.RenderControl(hw);
        string style = @"<style> .textmode { mso-number-format:\@; } </style>";
        Response.Write(style);
        Response.Output.Write(sw.ToString());
        Response.Flush();
        Response.End();
    }
}
